from pickle import FALSE
from die import Die
from tqdm import tqdm

class FiveDice:
    def __init__(self):
        self.dice = [Die() for number in range(5)]

    def roll(self):
        for die in self.dice:
            die.roll()
        return self.faces()

    def faces(self):
        return [die.face for die in self.dice]

    def all_ones(self):
        for face in self.faces():
            if face != 1:
                return False
        return True
    def is_three_of_a_kind(self):
        facesList = self.faces()
        facesList.sort()
        if facesList[0]==facesList[2]:
            return True
        elif facesList[1]==facesList[3]:
            return True
        elif facesList[3]==facesList[5]:
            return True
        else:
            return False
        
    def is_four_of_a_kind(self):
        facesList = self.faces()
        facesList.sort()
        if facesList[0]==facesList[3]:
            return True
        elif facesList[1]==facesList[4]:
            return True
        else:
            return False

    
    def different_three_of_a_kind(self):
        facesList = self.faces()
        for i in range(0, 2, 1):
            maxCount = 0
            for j in range(i, 4, 1):
                if facesList[i] == facesList[j]:
                    maxCount += 1
            if maxCount >= 3:
                return True
        return False
    
    def different_four_of_a_kind(self):
        facesList = self.faces()
        for i in range(0, 1, 1):
            maxCount = 0
            for j in range(i, 4, 1):
                if facesList[i] == facesList[j]:
                    maxCount += 1    
            if maxCount >= 4:
                return True
        return False

dice = FiveDice()
successes = 0
trials = 1000000
for trial in tqdm(range(trials)):
    dice.roll()
    if dice.all_ones():
        successes += 1

print(successes/trials)

